#!/usr/bin/python

#
# NOTE: This only works on LINUX, due to access limits on Windows
#

import socket
import struct
import binascii

# creating a rawSocket for communications


rawSocket = socket.socket(socket.PF_PACKET, socket.SOCK_RAW, socket.IPPROTO_IP)   # socket.htons(0x0800))

#rawSocket.bind('eth1', socket.htons(3))

# Include IP headers
# rawSocket.setsockopt(socket.IPPROTO_IP, socket.IP_HDRINCL, 1)

# receive all packages
rawSocket.ioctl(socket.SIO_RCVALL, socket.RCVALL_ON)



try:
    while True:

        # read a packet with recvfrom method
        pkt = rawSocket.recvfrom(2048) # tuple return
        if len(pkt) == 2:
            devName = pkt[1][0]

            if devName == 'eth1':

                print('Raw-Data: {0} / {1}'.format(len(pkt), devName))
        
                # Ethernet Header tuple segmentation
                eHeader = pkt[0][0:14]

                # parsing using unpack
                print('Header: {0}'.format(eHeader))

            # using hexlify to convert the tuple value NBO into Hex format
            #binascii.hexlify(eth_hdr[0])
            #binascii.hexlify(eth_hdr[1])
            #binascii.hexlify(eth_hdr[2])

except KeyboardInterrupt:
        print()
        rawSocket.close()

