

# NOTE: This only works on LINUX, due to access limits on Windows
# Works on FibreCode network-adapters FC602 (100BASE-T1) and FC621 (10BASE-T1L)
#

import os, sys
import time
import socket
import struct
import binascii

#DevName = 'eth0'
DevName = 'enx9ca2f4b61a20'

# creating a rawSocket for communications
# PF_SOCKET (packet interface), SOCK_RAW (Raw socket) - htons (protocol) 0x08000 = IP Protocol

ETH_P_ALL = 3
ETH_P_IP = 0x800

try:
    rawSocketTx = socket.socket(socket.PF_PACKET, socket.SOCK_RAW, socket.htons(ETH_P_ALL))
except:
    print('socket creation failed!. Is this MS-Windows maybe!')
    sys.exit(-1)



# deciding interface - Tx on eth0
rawSocketTx.bind((DevName, 0))  #socket.htons(0x0800)))


# create a ethernet packet
payload = 1492
macSrc = 'FC0011223344'


payloadData = ''
for j in range(0, payload):
    payloadData += '{0:02X}'.format(j & 0xFF)


frameId = 1

try:
    while True:

        #sendData = 'FFFFFFFFFFFF' + macSrc + '{0:04X}'.format(payload) + '1234' + '{0:08X}'.format(frameId) + '{0:04X}'.format(payload+6) + payloadData
        sendData = 'FFFFFFFFFFFF' + macSrc + '{0:04X}'.format(payload) + '1234' + '{0:08X}'.format(frameId) + '{0:04X}'.format(payload+6) + payloadData

        binData = binascii.a2b_hex(sendData)
        # 6 dest address, 6 source address and 2 for ethtype = IP

        # send preapred data incl. frameId as running counter
        rawSocketTx.send(binData)

        print('sending... {0}'.format(frameId))
        frameId += 1

        time.sleep(0.5)


except KeyboardInterrupt:
    rawSocketTx.close()
    
